package cn.net.caoyao.cpzshandset.service.presenter.impl.exchange.sheepEx;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.view.View;
import android.widget.Toast;
import cn.net.caoyao.cpzshandset.R;
import cn.net.caoyao.cpzshandset.bean.ConfigBean;
import cn.net.caoyao.cpzshandset.bean.ExchangeCargoBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.util.NetWorkUtils;
import cn.net.caoyao.cpzshandset.service.bll.BatchLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.SheepDealerBll;
import cn.net.caoyao.cpzshandset.service.bll.ExchangeCargoBll;
import cn.net.caoyao.cpzshandset.service.bll.SingleLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.config.ConfigBll;
import cn.net.caoyao.cpzshandset.service.presenter.OptionHisListStyleConstact;
import cn.net.caoyao.cpzshandset.service.presenter.base.impl.OptionHisListStyleConstactImpl;
import cn.net.caoyao.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.caoyao.cpzshandset.service.thread.impl.common.CommonCheckLabelThread;
import cn.net.caoyao.cpzshandset.ui.activity.BatchLabelScannerActivity;
import cn.net.caoyao.cpzshandset.ui.activity.ExchangeCargoConfigActivity;
import cn.net.caoyao.cpzshandset.ui.activity.SingleLabelScannerActivity;
import cn.net.caoyao.cpzshandset.ui.adapter.ExCargoHisListAdapter;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog.DClick;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog.DSure;
import cn.net.caoyao.cpzshandset.ui.weight.DialogUtils;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class SheepExCargoListPresenter extends OptionHisListStyleConstactImpl{
	private final OptionHisListStyleConstact.View hisView;
	private Context context;
	private ExCargoHisListAdapter adapter;
	private List<ExchangeCargoBean> aBeans = new ArrayList<ExchangeCargoBean>();
	private int createExCargoConfigReqCode=1001;
	private int modifyExCargoConfigReqCode=1002;
	private ExchangeCargoBll bll;
	private ConfigBll configBll;
	private SheepDealerBll dealerBll;
	private SingleLabelBll singleLabelBll;
	private BatchLabelBll batchLabelBll;
//	private UploadStatusBll uploadStatusBll;
	private TipsDialog tipsDialog;
	private OperationDialog operationDialog;
	private ProgressDialog bProgressDialog = null;
	private int currentHansetVersion = HandsetVersionConstant.HANDSET_SHEEP_EXCHANGE_CARGO;
	private HandsetOperation option_type = HandsetOperation.OPERATION_EXCHANGE_CARGO_CONSTANT;
	
	private Handler mHandler = new Handler(){
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case RequestConstant.REQUEST_FAIL:
				//请求失败
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				//超时
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				//登录失败
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				hisView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_SUCCESS:
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息成功，请在扫码界面中查看详细信息", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_FAIL:
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息失败", Toast.LENGTH_SHORT);
				break;
			}
		};
	};
	public SheepExCargoListPresenter(Context context,OptionHisListStyleConstact.View hisView) {
		super(hisView, context);
		this.hisView = hisView;
		this.context = context;
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable()) return;
		bll = new ExchangeCargoBll(context);
		configBll = new ConfigBll(context);
		hisView.setPageTitle("调货");
		hisView.setBottomBtnVisibility(View.GONE);
		hisView.setMoreOptionText(context.getResources().getString(R.string.new_create_str));
		adapter = new ExCargoHisListAdapter(aBeans,getDealerBll(),getSingelLabelBll(),getBatchLabelBll());
		hisView.setAdapter(adapter);
	}

	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr,
				tipsMsg, context);
	}
	
//	private UploadStatusBll getUploadStatusBll(){
//		if (uploadStatusBll == null) {
//			uploadStatusBll = new UploadStatusBll(context);
//		}
//		return uploadStatusBll;
//	}
	private BatchLabelBll getBatchLabelBll() {
		if (batchLabelBll == null) {
			batchLabelBll = new BatchLabelBll(context);
		}
		return batchLabelBll;
	}

	private SingleLabelBll getSingelLabelBll() {
		if (singleLabelBll == null) {
			singleLabelBll = new SingleLabelBll(context);
		}
		return singleLabelBll;
	}

	private SheepDealerBll getDealerBll() {
		if (dealerBll == null) {
			dealerBll = new SheepDealerBll(context);
		}
		return dealerBll;
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (hisView != null && context != null) {
			b = true;
		}
		return b;
	}

	@Override
	public void onItemClickListener(int position) {
		if (aBeans.size() == 0) {
			return;
		}
		ExchangeCargoBean a = aBeans.get(position);
		if (a.getOption_mode() == Config.SINGLE_OPTION_LABEL_TYPE) {
			//单标调货样式
			Intent intent = new Intent(context, SingleLabelScannerActivity.class);
			intent.putExtra("optionMode", option_type);
			intent.putExtra("currentCargoBean", a);
			context.startActivity(intent);
		} else {
			//批量调货样式
			Intent intent = new Intent(context, BatchLabelScannerActivity.class);
			intent.putExtra("optionMode", option_type);
			intent.putExtra("currentCargoBean", a);
			context.startActivity(intent);
		}
	}

	@Override
	public void onItemLongClickListener(int position) {
		if (!checkViewAvailable())return;
		if (aBeans.size() > 0) {
			showOptionDialog(position);
		}
		
	}

	private void showOptionDialog(final int position) {
		if (operationDialog == null) {
			operationDialog = new OperationDialog(context);
		}
		operationDialog.show();
//		if(aBeans.get(position).getOption_mode() == Config.SINGLE_OPTION_LABEL_TYPE){
//			operationDialog.setSearchViewVisiable(View.VISIBLE);
//		} else {
//			operationDialog.setSearchViewVisiable(View.GONE);
//		}
		operationDialog.setSearchViewVisiable(View.GONE);
		operationDialog.setDClick(position, new DClick() {
			
			@Override
			public void modifyClick() {
				//修改
				if (!checkViewAvailable()) return;
				Intent intent = new Intent(context, ExchangeCargoConfigActivity.class);
				intent.putExtra("isCreate", false);
				intent.putExtra("currentHisId", aBeans.get(position).getId());
				hisView.startAcForResult(createExCargoConfigReqCode, intent);
			}
			
			@Override
			public void delClick() {
				// 删除
				if (!checkViewAvailable()) return;
				String msg = "本条数据还未上传\n\n是否确定删除调货数据？\n\n确定删除后\n\n该数据对应的所有信息都会被删除" ;
				showWarnTipDialog(msg,position);
			}

			@Override
			public void searckClick() {
				if (!checkViewAvailable()) return;
				if (!NetWorkUtils.isNetworkConnected(context)) {
					DialogUtils.showSetNetDialog(context);
					return;
				}
				ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
				if (configBean == null) {
					hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
					return;
				}
				if (aBeans == null || aBeans.size() == 0) {
					hisView.showMsgToast("抱歉，当前的调货数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}
				
				List<String> labels = getSingelLabelBll().queryAllLabelStrById(option_type.getOption(), aBeans.get(position).getId());
				if (labels == null) {
					hisView.showMsgToast("抱歉，当前的调货数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}
				
				if (labels.size() == 0) {
					hisView.showMsgToast("抱歉，当前的调货数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}
				showProgressDialog("提示", "正在检测标签信息，请稍后……");
				long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
				ThreadPoolManager.getThreadPool().execute(new CommonCheckLabelThread(mHandler, deviceId, option_type, aBeans.get(position).getId(), labels, getSingelLabelBll()));				
			}
		});
		
	}
	
	protected void showWarnTipDialog(String msg,final int position) {
		if (tipsDialog == null) {
			tipsDialog = new TipsDialog(context);
		}
		tipsDialog.show();
		tipsDialog.setDelWarnView("警告", msg, position, false, new DSure() {
			
			@Override
			public void sureClick() {
				bll.deleteExchangeCargoById(aBeans.get(position));
				aBeans = bll.queryAllExchangeCargoDesc();
				adapter.refreshExCargoHisData(aBeans);
				hisView.showMsgToast("删除成功！", Toast.LENGTH_SHORT);
			}
		});
		
	}


	@Override
	public void backBtnClick() {
		if (!checkViewAvailable()) return;
		hisView.finishPage();
	}

	@Override
	public void moreOptionClick() {
		if (!checkViewAvailable()) return;
		Intent intent = new Intent(context, ExchangeCargoConfigActivity.class);
		intent.putExtra("isCreate", true);
		hisView.startAcForResult(createExCargoConfigReqCode, intent);
//		hisView.showMsgToast("新建", Toast.LENGTH_SHORT);
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		
	}

	@Override
	public void onResume() {
		aBeans = bll.queryAllExchangeCargoDesc();
//		LogUtil.e(TConfig.Echo, "aBeans:" + aBeans.toString());
		adapter.refreshExCargoHisData(aBeans);
		
	}

	@Override
	public void uploadAllHisList() {}
	
}
